igeo

## Class IParticleOnCurveGeo

- java.lang.Object
- - igeo.IDynamicsBase
  - - igeo.IParticleGeo
    - - igeo.IParticleOnCurveGeo

- All Implemented Interfaces:
    IArithmeticVal<IVecI,IDoubleI>, IDynamics, IParameter, IParticleI, IParticleOnCurveI, ISubobject, ITransformable, IVal, IVecI, IVecOp

      public class IParticleOnCurveGeo
      extends IParticleGeo
      implements IParticleOnCurveI

  Class of an implementation of IDynamics to have physical attributes of point on a curve.
  Author:
    Satoru Sugihara

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `ICurveI` | `curve`
    `double` | `ufrc`
    `double` | `upos`
    `IVec` | `utan`
    `double` | `uvel`

    - ### Fields inherited from class igeo.IParticleGeo

      `defaultFriction, fixed, frc, friction, mass, pos, skipUpdateOnce, vel`

    - ### Fields inherited from class igeo.IDynamicsBase

      `parent, targets`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IParticleOnCurveGeo(ICurve curve)`
    `IParticleOnCurveGeo(ICurve curve, double u)`
    `IParticleOnCurveGeo(ICurve curve, double u, double uvl)`
    `IParticleOnCurveGeo(ICurve curve, double u, double uvl, IVec pos)`
    `IParticleOnCurveGeo(ICurve curve, double u, IVec pos)`
    `IParticleOnCurveGeo(ICurveI curve)`
    `IParticleOnCurveGeo(ICurveI curve, double u)`
    `IParticleOnCurveGeo(ICurveI curve, double u, double uvl)`
    `IParticleOnCurveGeo(ICurveI curve, double u, double uvl, IObject parent)`
    `IParticleOnCurveGeo(ICurveI curve, double u, double uvl, IPoint pt)`
    `IParticleOnCurveGeo(ICurveI curve, double u, double uvl, IPointR pt)`
    `IParticleOnCurveGeo(ICurveI curve, double u, double uvl, IVec pos)`
    `IParticleOnCurveGeo(ICurveI curve, double u, double uvl, IVec pos, IObject parent)`
    `IParticleOnCurveGeo(ICurveI curve, double u, IObject parent)`
    `IParticleOnCurveGeo(ICurveI curve, double u, IPoint pt)`
    `IParticleOnCurveGeo(ICurveI curve, double u, IPointR pt)`
    `IParticleOnCurveGeo(ICurveI curve, double u, IVec pos)`
    `IParticleOnCurveGeo(ICurveI curve, double u, IVec pos, IObject parent)`
    `IParticleOnCurveGeo(ICurveI curve, IObject parent)`
    `IParticleOnCurveGeo(ICurveI curve, IPoint pt)`
    `IParticleOnCurveGeo(ICurveI curve, IPointR pt)`
    `IParticleOnCurveGeo(ICurveI curve, IVec pos)`
    `IParticleOnCurveGeo(ICurveI curve, IVec pos, IObject parent)`
    `IParticleOnCurveGeo(ICurve curve, IVec pos)`
    `IParticleOnCurveGeo(IParticleOnCurveGeo p)`
    `IParticleOnCurveGeo(IParticleOnCurveGeo p, IObject parent)`
    `IParticleOnCurveGeo(IParticleOnCurveGeo p, IVec pos)`
    `IParticleOnCurveGeo(IParticleOnCurveGeo p, IVec pos, IObject parent)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `IParticleOnCurveGeo` | `add(double x, double y, double z)`
    `IParticleOnCurveGeo` | `add(double f, IVecI v)` scale add
    `IParticleOnCurveGeo` | `add(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IParticleOnCurveGeo` | `add(IDoubleI f, IVecI v)` scale add
    `IParticleOnCurveGeo` | `add(IVecI v)`
    `IParticleOnCurveGeo` | `add(IVecI v, double f)` scale add
    `IParticleOnCurveGeo` | `add(IVecI v, IDoubleI f)` scale add
    `IParticleOnCurveGeo` | `addForce(IVecI f)` adding force (alias of push)
    `IParticleOnCurveGeo` | `addUForce(double uforce)`
    `IParticleOnCurveGeo` | `cp()` cp() is alias of dup()
    `IParticleOnCurveGeo` | `cp(double x, double y, double z)` cp() is alias of dup().add()
    `IParticleOnCurveGeo` | `cp(IDoubleI x, IDoubleI y, IDoubleI z)` cp() is alias of dup().add()
    `IParticleOnCurveGeo` | `cp(IVecI v)` cp() is alias of dup().add()
    `ICurveI` | `curve()`
    `IParticleOnCurveGeo` | `decay(double d)`
    `IParticleOnCurveGeo` | `div(double v)`
    `IParticleOnCurveGeo` | `div(IDoubleI v)`
    `IParticleOnCurveGeo` | `dup()` duplicate the instance
    `IParticleOnCurveGeo` | `fix()` fix movement
    `IParticleOnCurveGeo` | `flip()` alias of neg()
    `IParticleOnCurveGeo` | `force(IVecI v)` set force
    `IParticleOnCurveGeo` | `frc(IVecI v)` set force
    `IParticleOnCurveGeo` | `fric(double friction)` set friction
    `IParticleOnCurveGeo` | `friction(double friction)` set friction
    `void` | `interact(java.util.ArrayList<IDynamics> dynamics)` behavior definition of interaction with other dynamic objects.
    `IParticleOnCurveGeo` | `mass(double mass)` set mass
    `IParticleOnCurveGeo` | `mirror(double planeX, double planeY, double planeZ)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IParticleOnCurveGeo` | `mirror(double centerX, double centerY, double centerZ, double planeX, double planeY, double planeZ)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IParticleOnCurveGeo` | `mirror(IVecI planeDir)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IParticleOnCurveGeo` | `mirror(IVecI center, IVecI planeDir)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IParticleOnCurveGeo` | `mul(double v)`
    `IParticleOnCurveGeo` | `mul(IDoubleI v)`
    `IParticleOnCurveGeo` | `mv(double x, double y, double z)` mv() is alias of add()
    `IParticleOnCurveGeo` | `mv(IDoubleI x, IDoubleI y, IDoubleI z)` mv() is alias of add()
    `IParticleOnCurveGeo` | `mv(IVecI v)` mv() is alias of add()
    `IParticleOnCurveGeo` | `neg()`
    `IParticleOnCurveGeo` | `pos(IVecI v)` set position
    `IParticleOnCurveGeo` | `position(IVecI v)` set position
    `void` | `postupdate()` this is changed again because force in update cannot be reflected (updated 2014/03/10)
    `void` | `preupdate()` update of velocity is done in preupdate (updated 2012/08/26)
    `IParticleOnCurveGeo` | `pull(IVecI f)` adding negative force
    `IParticleOnCurveGeo` | `push(IVecI f)` adding force
    `IParticleOnCurveGeo` | `ref(double planeX, double planeY, double planeZ)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IParticleOnCurveGeo` | `ref(double centerX, double centerY, double centerZ, double planeX, double planeY, double planeZ)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IParticleOnCurveGeo` | `ref(IVecI planeDir)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IParticleOnCurveGeo` | `ref(IVecI center, IVecI planeDir)` reflect (mirror) 3 dimensionally to the other side of the plane
    `IParticleOnCurveGeo` | `reset()` setting force zero
    `IParticleOnCurveGeo` | `resetForce()` setting force zero (alias of reset())
    `IParticleOnCurveGeo` | `resetUForce()`
    `IParticleOnCurveGeo` | `rev()` alias of neg()
    `IParticleOnCurveGeo` | `rot(double angle)` rotation on XY plane
    `IParticleOnCurveGeo` | `rot(double axisX, double axisY, double axisZ, double angle)` rotation around axis vector
    `IParticleOnCurveGeo` | `rot(double centerX, double centerY, double centerZ, double axisX, double axisY, double axisZ, double angle)` rotation around axis vector and center point
    `IParticleOnCurveGeo` | `rot(IDoubleI angle)` rotation on XY plane
    `IParticleOnCurveGeo` | `rot(IVecI axis, double angle)` rotation around axis vector
    `IParticleOnCurveGeo` | `rot(IVecI axis, IDoubleI angle)` rotation around axis vector
    `IParticleOnCurveGeo` | `rot(IVecI axis, IVecI destDir)` Rotate to destination direction vector.
    `IParticleOnCurveGeo` | `rot(IVecI center, IVecI axis, double angle)` rotation around axis vector and center point
    `IParticleOnCurveGeo` | `rot(IVecI center, IVecI axis, IDoubleI angle)` rotation around axis vector and center point
    `IParticleOnCurveGeo` | `rot(IVecI center, IVecI axis, IVecI destPt)` Rotate to destination point location.
    `IParticleOnCurveGeo` | `rot2(double angle)` rotation on xy-plane; alias of rot(double)
    `IParticleOnCurveGeo` | `rot2(double centerX, double centerY, double angle)` rotation on xy-plane
    `IParticleOnCurveGeo` | `rot2(IDoubleI angle)` rotation on xy-plane; alias of rot(IDoubleI)
    `IParticleOnCurveGeo` | `rot2(IVecI destDir)` rotation on xy-plane towards destDir
    `IParticleOnCurveGeo` | `rot2(IVecI center, double angle)` rotation on xy-plane
    `IParticleOnCurveGeo` | `rot2(IVecI center, IDoubleI angle)` rotation on xy-plane
    `IParticleOnCurveGeo` | `rot2(IVecI center, IVecI destPt)` rotation on xy-plane towards destPt
    `IParticleOnCurveGeo` | `scale(double f)` alias of mul
    `IParticleOnCurveGeo` | `scale(double centerX, double centerY, double centerZ, double f)` scale from a center
    `IParticleOnCurveGeo` | `scale(IDoubleI f)` alias of mul
    `IParticleOnCurveGeo` | `scale(IVecI center, double f)` scale from a center
    `IParticleOnCurveGeo` | `scale(IVecI center, IDoubleI f)` scale from a center
    `IParticleOnCurveGeo` | `scale1d(double axisX, double axisY, double axisZ, double f)` scale only in 1 direction
    `IParticleOnCurveGeo` | `scale1d(double centerX, double centerY, double centerZ, double axisX, double axisY, double axisZ, double f)` scale only in 1 direction from a center
    `IParticleOnCurveGeo` | `scale1d(IVecI axis, double f)` scale only in 1 direction
    `IParticleOnCurveGeo` | `scale1d(IVecI axis, IDoubleI f)` scale only in 1 direction
    `IParticleOnCurveGeo` | `scale1d(IVecI center, IVecI axis, double f)` scale only in 1 direction from a center
    `IParticleOnCurveGeo` | `scale1d(IVecI center, IVecI axis, IDoubleI f)` scale only in 1 direction from a center
    `IParticleOnCurveGeo` | `set(double x, double y, double z)`
    `IParticleOnCurveGeo` | `set(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IParticleOnCurveGeo` | `set(IVecI v)`
    `IParticleOnCurveGeo` | `shear(double sxy, double syx, double syz, double szy, double szx, double sxz)` shear operation
    `IParticleOnCurveGeo` | `shear(IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)` shear operation
    `IParticleOnCurveGeo` | `shear(IVecI center, double sxy, double syx, double syz, double szy, double szx, double sxz)` shear operation
    `IParticleOnCurveGeo` | `shear(IVecI center, IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)` shear operation
    `IParticleOnCurveGeo` | `shearXY(double sxy, double syx)` shear operation on XY
    `IParticleOnCurveGeo` | `shearXY(IDoubleI sxy, IDoubleI syx)` shear operation on XY
    `IParticleOnCurveGeo` | `shearXY(IVecI center, double sxy, double syx)` shear operation on XY
    `IParticleOnCurveGeo` | `shearXY(IVecI center, IDoubleI sxy, IDoubleI syx)` shear operation on XY
    `IParticleOnCurveGeo` | `shearYZ(double syz, double szy)` shear operation on YZ
    `IParticleOnCurveGeo` | `shearYZ(IDoubleI syz, IDoubleI szy)` shear operation on YZ
    `IParticleOnCurveGeo` | `shearYZ(IVecI center, double syz, double szy)` shear operation on YZ
    `IParticleOnCurveGeo` | `shearYZ(IVecI center, IDoubleI syz, IDoubleI szy)` shear operation on YZ
    `IParticleOnCurveGeo` | `shearZX(double szx, double sxz)` shear operation on ZX
    `IParticleOnCurveGeo` | `shearZX(IDoubleI szx, IDoubleI sxz)` shear operation on ZX
    `IParticleOnCurveGeo` | `shearZX(IVecI center, double szx, double sxz)` shear operation on ZX
    `IParticleOnCurveGeo` | `shearZX(IVecI center, IDoubleI szx, IDoubleI sxz)` shear operation on ZX
    `IParticleOnCurveGeo` | `skipUpdateOnce(boolean f)` for other agent to control particle
    `IParticleOnCurveGeo` | `sub(double x, double y, double z)`
    `IParticleOnCurveGeo` | `sub(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IParticleOnCurveGeo` | `sub(IVecI v)`
    `IParticleOnCurveGeo` | `transform(IMatrix3I mat)` transform with a transformation matrix
    `IParticleOnCurveGeo` | `transform(IMatrix4I mat)` transform with a transformation matrix
    `IParticleOnCurveGeo` | `transform(IVecI xvec, IVecI yvec, IVecI zvec)` transform with a transformation vectors
    `IParticleOnCurveGeo` | `transform(IVecI xvec, IVecI yvec, IVecI zvec, IVecI translate)` transform with a transformation vectors
    `IParticleOnCurveGeo` | `translate(double x, double y, double z)` translate is alias of add()
    `IParticleOnCurveGeo` | `translate(IDoubleI x, IDoubleI y, IDoubleI z)` alias of add()
    `IParticleOnCurveGeo` | `translate(IVecI v)` alias of add()
    `double` | `uforce()`
    `IParticleOnCurveGeo` | `uforce(double uf)`
    `double` | `ufrc()`
    `IParticleOnCurveGeo` | `ufrc(double uf)`
    `IParticleOnCurveGeo` | `unfix()` unfix movement
    `IParticleOnCurveGeo` | `unit()` unitize
    `void` | `update()` update of velocity is done in preupdate and update of position is done in update() (updated 2012/08/26)
    `double` | `upos()`
    `IParticleOnCurveGeo` | `upos(double u)`
    `double` | `uposition()`
    `IParticleOnCurveGeo` | `uposition(double u)`
    `IParticleOnCurveGeo` | `upull(double uforce)`
    `IParticleOnCurveGeo` | `upush(double uforce)`
    `IParticleOnCurveGeo` | `ureset()`
    `double` | `uvel()`
    `IParticleOnCurveGeo` | `uvel(double uv)`
    `double` | `uvelocity()`
    `IParticleOnCurveGeo` | `uvelocity(double uv)`
    `IParticleOnCurveGeo` | `vel(IVecI v)` set velocity
    `IParticleOnCurveGeo` | `velocity(IVecI v)` set velocity
    `IParticleOnCurveGeo` | `x(double vx)` implementation of IVecI
    `IParticleOnCurveGeo` | `x(IDoubleI vx)` setting x component
    `IParticleOnCurveGeo` | `x(IVec2I vx)` setting x component by x component of input vector
    `IParticleOnCurveGeo` | `x(IVecI vx)` setting x component by x component of input vector
    `IParticleOnCurveGeo` | `y(double vy)` setting y component
    `IParticleOnCurveGeo` | `y(IDoubleI vy)` setting y component
    `IParticleOnCurveGeo` | `y(IVec2I vy)` setting y component by y component of input vector
    `IParticleOnCurveGeo` | `y(IVecI vy)` setting y component by y component of input vector
    `IParticleOnCurveGeo` | `z(double vz)` setting z component
    `IParticleOnCurveGeo` | `z(IDoubleI vz)` setting z component
    `IParticleOnCurveGeo` | `z(IVecI vz)` setting z component by z component of input vector
    `IParticleOnCurveGeo` | `zero()` setting all zero

    - ### Methods inherited from class igeo.IParticleGeo

      `acc, acceleration, addForce, angle, angle, angle, angle, angle, angle, angle, angle, bisect, bisect, cross, cross, decay, dif, dif, diff, diff, dist, dist, dist, dist, dist2, dist2, dist2, dist2, dot, dot, dot, dot, eq, eq, eq, eq, eq, eq, eq, eq, eqX, eqX, eqX, eqX, eqX, eqX, eqX, eqX, eqY, eqY, eqY, eqY, eqY, eqY, eqY, eqY, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, fixed, force, frc, fric, friction, get, getX, getY, getZ, initParticle, initParticle, initParticle, isValid, len, len, len, len, len, len2, len2, len2, mass, mid, mid, nml, nml, nml, nml, pos, position, pull, push, removeTarget, removeTarget, skipUpdateOnce, sum, sum, sum, sum, sum, sum, sum, target, to2d, to2d, to2d, to2d, to4d, to4d, to4d, toString, vel, velocity, x, x, x, y, y, y, z, z, z`

    - ### Methods inherited from class igeo.IDynamicsBase

      `initDynamicsBase, initDynamicsBase, initDynamicsBase, localDynamics, parent, parent, postinteract, preinteract, target, targetNum, targets, updateTarget`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface igeo.IParticleI

      `acc, acceleration, addForce, decay, fixed, force, frc, fric, friction, mass, pos, position, pull, push, removeTarget, removeTarget, skipUpdateOnce, target, target, targetNum, targets, updateTarget, vel, velocity`

    - ### Methods inherited from interface igeo.IVecI

      `angle, angle, angle, angle, angle, angle, angle, angle, bisect, bisect, cross, cross, dif, dif, diff, diff, dist, dist, dist, dist, dist2, dist2, dist2, dist2, dot, dot, dot, dot, eq, eq, eq, eq, eq, eq, eq, eq, eqX, eqX, eqX, eqX, eqX, eqX, eqX, eqX, eqY, eqY, eqY, eqY, eqY, eqY, eqY, eqY, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, eqZ, get, getX, getY, getZ, isValid, len, len, len, len, len, len2, len2, len2, mid, mid, nml, nml, nml, nml, sum, sum, sum, sum, sum, sum, sum, to2d, to2d, to2d, to2d, to4d, to4d, to4d, x, x, x, y, y, y, z, z, z`

- - ### Field Detail

    - #### curve

          public ICurveI curve

    - #### upos

          public double upos

    - #### uvel

          public double uvel

    - #### ufrc

          public double ufrc

    - #### utan

          public IVec utan

  - ### Constructor Detail

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     double u)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     double u,
                                     double uvl)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     IVec pos)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     double u,
                                     IVec pos)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     double u,
                                     double uvl,
                                     IVec pos)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     IObject parent)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     double u,
                                     IObject parent)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     double u,
                                     double uvl,
                                     IObject parent)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     IVec pos,
                                     IObject parent)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     double u,
                                     IVec pos,
                                     IObject parent)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     double u,
                                     double uvl,
                                     IVec pos,
                                     IObject parent)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     double u,
                                     IPoint pt)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     double u,
                                     double uvl,
                                     IPoint pt)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     IPoint pt)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     IPointR pt)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     double u,
                                     IPointR pt)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurveI curve,
                                     double u,
                                     double uvl,
                                     IPointR pt)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurve curve)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurve curve,
                                     double u)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurve curve,
                                     double u,
                                     double uvl)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurve curve,
                                     IVec pos)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurve curve,
                                     double u,
                                     IVec pos)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(ICurve curve,
                                     double u,
                                     double uvl,
                                     IVec pos)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(IParticleOnCurveGeo p)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(IParticleOnCurveGeo p,
                                     IVec pos)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(IParticleOnCurveGeo p,
                                     IObject parent)

    - #### IParticleOnCurveGeo

          public IParticleOnCurveGeo(IParticleOnCurveGeo p,
                                     IVec pos,
                                     IObject parent)

  - ### Method Detail

    - #### dup

          public IParticleOnCurveGeo dup()

      Description copied from interface: `ITransformable`
      duplicate the instance
      Specified by:
        `dup` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `dup` in interface `ITransformable`
      Specified by:
        `dup` in interface `IVecI`
      Overrides:
        `dup` in class `IParticleGeo`

    - #### curve

          public ICurveI curve()

      Specified by:
        `curve` in interface `IParticleOnCurveI`

    - #### fix

          public IParticleOnCurveGeo fix()

      Description copied from interface: `IParticleI`
      fix movement
      Specified by:
        `fix` in interface `IParticleI`
      Overrides:
        `fix` in class `IParticleGeo`

    - #### unfix

          public IParticleOnCurveGeo unfix()

      Description copied from interface: `IParticleI`
      unfix movement
      Specified by:
        `unfix` in interface `IParticleI`
      Overrides:
        `unfix` in class `IParticleGeo`

    - #### skipUpdateOnce

          public IParticleOnCurveGeo skipUpdateOnce(boolean f)

      Description copied from class: `IParticleGeo`
      for other agent to control particle
      Specified by:
        `skipUpdateOnce` in interface `IParticleI`
      Overrides:
        `skipUpdateOnce` in class `IParticleGeo`

    - #### mass

          public IParticleOnCurveGeo mass(double mass)

      Description copied from interface: `IParticleI`
      set mass
      Specified by:
        `mass` in interface `IParticleI`
      Overrides:
        `mass` in class `IParticleGeo`

    - #### position

          public IParticleOnCurveGeo position(IVecI v)

      Description copied from interface: `IParticleI`
      set position
      Specified by:
        `position` in interface `IParticleI`
      Overrides:
        `position` in class `IParticleGeo`

    - #### pos

          public IParticleOnCurveGeo pos(IVecI v)

      Description copied from interface: `IParticleI`
      set position
      Specified by:
        `pos` in interface `IParticleI`
      Overrides:
        `pos` in class `IParticleGeo`

    - #### velocity

          public IParticleOnCurveGeo velocity(IVecI v)

      Description copied from interface: `IParticleI`
      set velocity
      Specified by:
        `velocity` in interface `IParticleI`
      Overrides:
        `velocity` in class `IParticleGeo`

    - #### vel

          public IParticleOnCurveGeo vel(IVecI v)

      Description copied from interface: `IParticleI`
      set velocity
      Specified by:
        `vel` in interface `IParticleI`
      Overrides:
        `vel` in class `IParticleGeo`

    - #### force

          public IParticleOnCurveGeo force(IVecI v)

      Description copied from interface: `IParticleI`
      set force
      Specified by:
        `force` in interface `IParticleI`
      Overrides:
        `force` in class `IParticleGeo`

    - #### frc

          public IParticleOnCurveGeo frc(IVecI v)

      Description copied from interface: `IParticleI`
      set force
      Specified by:
        `frc` in interface `IParticleI`
      Overrides:
        `frc` in class `IParticleGeo`

    - #### friction

          public IParticleOnCurveGeo friction(double friction)

      Description copied from interface: `IParticleI`
      set friction
      Specified by:
        `friction` in interface `IParticleI`
      Overrides:
        `friction` in class `IParticleGeo`

    - #### fric

          public IParticleOnCurveGeo fric(double friction)

      Description copied from interface: `IParticleI`
      set friction
      Specified by:
        `fric` in interface `IParticleI`
      Overrides:
        `fric` in class `IParticleGeo`

    - #### decay

          public IParticleOnCurveGeo decay(double d)

      Specified by:
        `decay` in interface `IParticleI`
      Overrides:
        `decay` in class `IParticleGeo`

    - #### push

          public IParticleOnCurveGeo push(IVecI f)

      Description copied from class: `IParticleGeo`
      adding force
      Specified by:
        `push` in interface `IParticleI`
      Overrides:
        `push` in class `IParticleGeo`

    - #### pull

          public IParticleOnCurveGeo pull(IVecI f)

      Description copied from class: `IParticleGeo`
      adding negative force
      Specified by:
        `pull` in interface `IParticleI`
      Overrides:
        `pull` in class `IParticleGeo`

    - #### addForce

          public IParticleOnCurveGeo addForce(IVecI f)

      Description copied from class: `IParticleGeo`
      adding force (alias of push)
      Specified by:
        `addForce` in interface `IParticleI`
      Overrides:
        `addForce` in class `IParticleGeo`

    - #### reset

          public IParticleOnCurveGeo reset()

      Description copied from class: `IParticleGeo`
      setting force zero
      Specified by:
        `reset` in interface `IParticleI`
      Overrides:
        `reset` in class `IParticleGeo`

    - #### resetForce

          public IParticleOnCurveGeo resetForce()

      Description copied from class: `IParticleGeo`
      setting force zero (alias of reset())
      Specified by:
        `resetForce` in interface `IParticleI`
      Overrides:
        `resetForce` in class `IParticleGeo`

    - #### uposition

          public IParticleOnCurveGeo uposition(double u)

      Specified by:
        `uposition` in interface `IParticleOnCurveI`

    - #### upos

          public IParticleOnCurveGeo upos(double u)

      Specified by:
        `upos` in interface `IParticleOnCurveI`

    - #### uposition

          public double uposition()

      Specified by:
        `uposition` in interface `IParticleOnCurveI`

    - #### upos

          public double upos()

      Specified by:
        `upos` in interface `IParticleOnCurveI`

    - #### uvelocity

          public IParticleOnCurveGeo uvelocity(double uv)

      Specified by:
        `uvelocity` in interface `IParticleOnCurveI`

    - #### uvel

          public IParticleOnCurveGeo uvel(double uv)

      Specified by:
        `uvel` in interface `IParticleOnCurveI`

    - #### uvelocity

          public double uvelocity()

      Specified by:
        `uvelocity` in interface `IParticleOnCurveI`

    - #### uvel

          public double uvel()

      Specified by:
        `uvel` in interface `IParticleOnCurveI`

    - #### uforce

          public IParticleOnCurveGeo uforce(double uf)

      Specified by:
        `uforce` in interface `IParticleOnCurveI`

    - #### ufrc

          public IParticleOnCurveGeo ufrc(double uf)

      Specified by:
        `ufrc` in interface `IParticleOnCurveI`

    - #### uforce

          public double uforce()

      Specified by:
        `uforce` in interface `IParticleOnCurveI`

    - #### ufrc

          public double ufrc()

      Specified by:
        `ufrc` in interface `IParticleOnCurveI`

    - #### addUForce

          public IParticleOnCurveGeo addUForce(double uforce)

      Specified by:
        `addUForce` in interface `IParticleOnCurveI`

    - #### resetUForce

          public IParticleOnCurveGeo resetUForce()

      Specified by:
        `resetUForce` in interface `IParticleOnCurveI`

    - #### upush

          public IParticleOnCurveGeo upush(double uforce)

      Specified by:
        `upush` in interface `IParticleOnCurveI`

    - #### upull

          public IParticleOnCurveGeo upull(double uforce)

      Specified by:
        `upull` in interface `IParticleOnCurveI`

    - #### ureset

          public IParticleOnCurveGeo ureset()

      Specified by:
        `ureset` in interface `IParticleOnCurveI`

    - #### interact

          public void interact(java.util.ArrayList<IDynamics> dynamics)

      Description copied from class: `IDynamicsBase`
      behavior definition of interaction with other dynamic objects. The server puts all dynamic objects including itself.
      Specified by:
        `interact` in interface `IDynamics`
      Overrides:
        `interact` in class `IDynamicsBase`

    - #### preupdate

          public void preupdate()

      update of velocity is done in preupdate (updated 2012/08/26)
      Specified by:
        `preupdate` in interface `IDynamics`
      Overrides:
        `preupdate` in class `IParticleGeo`

    - #### update

          public void update()

      update of velocity is done in preupdate and update of position is done in update() (updated 2012/08/26)
      Specified by:
        `update` in interface `IDynamics`
      Overrides:
        `update` in class `IParticleGeo`

    - #### postupdate

          public void postupdate()

      Description copied from class: `IParticleGeo`
      this is changed again because force in update cannot be reflected (updated 2014/03/10)
      Specified by:
        `postupdate` in interface `IDynamics`
      Overrides:
        `postupdate` in class `IParticleGeo`

    - #### x

          public IParticleOnCurveGeo x(double vx)

      implementation of IVecI
      Specified by:
        `x` in interface `IVecI`
      Overrides:
        `x` in class `IParticleGeo`

    - #### y

          public IParticleOnCurveGeo y(double vy)

      Description copied from interface: `IVecI`
      setting y component
      Specified by:
        `y` in interface `IVecI`
      Overrides:
        `y` in class `IParticleGeo`

    - #### z

          public IParticleOnCurveGeo z(double vz)

      Description copied from interface: `IVecI`
      setting z component
      Specified by:
        `z` in interface `IVecI`
      Overrides:
        `z` in class `IParticleGeo`

    - #### x

          public IParticleOnCurveGeo x(IDoubleI vx)

      Description copied from interface: `IVecI`
      setting x component
      Specified by:
        `x` in interface `IVecI`
      Overrides:
        `x` in class `IParticleGeo`

    - #### y

          public IParticleOnCurveGeo y(IDoubleI vy)

      Description copied from interface: `IVecI`
      setting y component
      Specified by:
        `y` in interface `IVecI`
      Overrides:
        `y` in class `IParticleGeo`

    - #### z

          public IParticleOnCurveGeo z(IDoubleI vz)

      Description copied from interface: `IVecI`
      setting z component
      Specified by:
        `z` in interface `IVecI`
      Overrides:
        `z` in class `IParticleGeo`

    - #### x

          public IParticleOnCurveGeo x(IVecI vx)

      Description copied from class: `IParticleGeo`
      setting x component by x component of input vector
      Specified by:
        `x` in interface `IVecI`
      Overrides:
        `x` in class `IParticleGeo`

    - #### y

          public IParticleOnCurveGeo y(IVecI vy)

      Description copied from class: `IParticleGeo`
      setting y component by y component of input vector
      Specified by:
        `y` in interface `IVecI`
      Overrides:
        `y` in class `IParticleGeo`

    - #### z

          public IParticleOnCurveGeo z(IVecI vz)

      Description copied from class: `IParticleGeo`
      setting z component by z component of input vector
      Specified by:
        `z` in interface `IVecI`
      Overrides:
        `z` in class `IParticleGeo`

    - #### x

          public IParticleOnCurveGeo x(IVec2I vx)

      Description copied from class: `IParticleGeo`
      setting x component by x component of input vector
      Specified by:
        `x` in interface `IVecI`
      Overrides:
        `x` in class `IParticleGeo`

    - #### y

          public IParticleOnCurveGeo y(IVec2I vy)

      Description copied from class: `IParticleGeo`
      setting y component by y component of input vector
      Specified by:
        `y` in interface `IVecI`
      Overrides:
        `y` in class `IParticleGeo`

    - #### set

          public IParticleOnCurveGeo set(IVecI v)

      Specified by:
        `set` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `set` in interface `IVecI`
      Overrides:
        `set` in class `IParticleGeo`

    - #### set

          public IParticleOnCurveGeo set(double x,
                                         double y,
                                         double z)

      Specified by:
        `set` in interface `IVecI`
      Overrides:
        `set` in class `IParticleGeo`

    - #### set

          public IParticleOnCurveGeo set(IDoubleI x,
                                         IDoubleI y,
                                         IDoubleI z)

      Specified by:
        `set` in interface `IVecI`
      Overrides:
        `set` in class `IParticleGeo`

    - #### add

          public IParticleOnCurveGeo add(double x,
                                         double y,
                                         double z)

      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IParticleGeo`

    - #### add

          public IParticleOnCurveGeo add(IDoubleI x,
                                         IDoubleI y,
                                         IDoubleI z)

      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IParticleGeo`

    - #### add

          public IParticleOnCurveGeo add(IVecI v)

      Specified by:
        `add` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IParticleGeo`

    - #### sub

          public IParticleOnCurveGeo sub(double x,
                                         double y,
                                         double z)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in interface `IVecI`
      Overrides:
        `sub` in class `IParticleGeo`

    - #### sub

          public IParticleOnCurveGeo sub(IDoubleI x,
                                         IDoubleI y,
                                         IDoubleI z)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in interface `IVecI`
      Overrides:
        `sub` in class `IParticleGeo`

    - #### sub

          public IParticleOnCurveGeo sub(IVecI v)

      Specified by:
        `sub` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in interface `IVecI`
      Overrides:
        `sub` in class `IParticleGeo`

    - #### mul

          public IParticleOnCurveGeo mul(IDoubleI v)

      Specified by:
        `mul` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `mul` in interface `ITransformable`
      Specified by:
        `mul` in interface `IVecI`
      Overrides:
        `mul` in class `IParticleGeo`

    - #### mul

          public IParticleOnCurveGeo mul(double v)

      Specified by:
        `mul` in interface `ITransformable`
      Specified by:
        `mul` in interface `IVecI`
      Overrides:
        `mul` in class `IParticleGeo`

    - #### div

          public IParticleOnCurveGeo div(IDoubleI v)

      Specified by:
        `div` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `div` in interface `ITransformable`
      Specified by:
        `div` in interface `IVecI`
      Overrides:
        `div` in class `IParticleGeo`

    - #### div

          public IParticleOnCurveGeo div(double v)

      Specified by:
        `div` in interface `ITransformable`
      Specified by:
        `div` in interface `IVecI`
      Overrides:
        `div` in class `IParticleGeo`

    - #### neg

          public IParticleOnCurveGeo neg()

      Specified by:
        `neg` in interface `ITransformable`
      Specified by:
        `neg` in interface `IVecI`
      Overrides:
        `neg` in class `IParticleGeo`

    - #### rev

          public IParticleOnCurveGeo rev()

      Description copied from interface: `IVecI`
      alias of neg()
      Specified by:
        `rev` in interface `IVecI`
      Overrides:
        `rev` in class `IParticleGeo`

    - #### flip

          public IParticleOnCurveGeo flip()

      Description copied from interface: `IVecI`
      alias of neg()
      Specified by:
        `flip` in interface `ITransformable`
      Specified by:
        `flip` in interface `IVecI`
      Overrides:
        `flip` in class `IParticleGeo`

    - #### zero

          public IParticleOnCurveGeo zero()

      Description copied from interface: `IVecI`
      setting all zero
      Specified by:
        `zero` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `zero` in interface `IVecI`
      Overrides:
        `zero` in class `IParticleGeo`

    - #### add

          public IParticleOnCurveGeo add(IVecI v,
                                         double f)

      Description copied from interface: `IVecI`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IParticleGeo`

    - #### add

          public IParticleOnCurveGeo add(IVecI v,
                                         IDoubleI f)

      Description copied from interface: `IVecI`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IParticleGeo`

    - #### add

          public IParticleOnCurveGeo add(double f,
                                         IVecI v)

      Description copied from interface: `IVecI`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IParticleGeo`

    - #### add

          public IParticleOnCurveGeo add(IDoubleI f,
                                         IVecI v)

      Description copied from interface: `IVecI`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVecI`
      Overrides:
        `add` in class `IParticleGeo`

    - #### unit

          public IParticleOnCurveGeo unit()

      Description copied from interface: `IVecI`
      unitize
      Specified by:
        `unit` in interface `IVecI`
      Overrides:
        `unit` in class `IParticleGeo`

    - #### rot

          public IParticleOnCurveGeo rot(IDoubleI angle)

      Description copied from interface: `IVecI`
      rotation on XY plane
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IParticleOnCurveGeo rot(double angle)

      Description copied from interface: `IVecI`
      rotation on XY plane
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IParticleOnCurveGeo rot(IVecI axis,
                                         IDoubleI angle)

      Description copied from interface: `IVecI`
      rotation around axis vector
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IParticleOnCurveGeo rot(IVecI axis,
                                         double angle)

      Description copied from interface: `IVecI`
      rotation around axis vector
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IParticleOnCurveGeo rot(double axisX,
                                         double axisY,
                                         double axisZ,
                                         double angle)

      Description copied from interface: `IVecI`
      rotation around axis vector
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IParticleOnCurveGeo rot(IVecI center,
                                         IVecI axis,
                                         double angle)

      Description copied from interface: `IVecI`
      rotation around axis vector and center point
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IParticleOnCurveGeo rot(IVecI center,
                                         IVecI axis,
                                         IDoubleI angle)

      Description copied from interface: `IVecI`
      rotation around axis vector and center point
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IParticleOnCurveGeo rot(double centerX,
                                         double centerY,
                                         double centerZ,
                                         double axisX,
                                         double axisY,
                                         double axisZ,
                                         double angle)

      Description copied from interface: `IVecI`
      rotation around axis vector and center point
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IParticleOnCurveGeo rot(IVecI axis,
                                         IVecI destDir)

      Rotate to destination direction vector.
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot

          public IParticleOnCurveGeo rot(IVecI center,
                                         IVecI axis,
                                         IVecI destPt)

      Rotate to destination point location.
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVecI`
      Overrides:
        `rot` in class `IParticleGeo`

    - #### rot2

          public IParticleOnCurveGeo rot2(double angle)

      rotation on xy-plane; alias of rot(double)
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IParticleGeo`

    - #### rot2

          public IParticleOnCurveGeo rot2(IDoubleI angle)

      rotation on xy-plane; alias of rot(IDoubleI)
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IParticleGeo`

    - #### rot2

          public IParticleOnCurveGeo rot2(IVecI center,
                                          double angle)

      rotation on xy-plane
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IParticleGeo`

    - #### rot2

          public IParticleOnCurveGeo rot2(IVecI center,
                                          IDoubleI angle)

      rotation on xy-plane
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IParticleGeo`

    - #### rot2

          public IParticleOnCurveGeo rot2(double centerX,
                                          double centerY,
                                          double angle)

      rotation on xy-plane
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IParticleGeo`

    - #### rot2

          public IParticleOnCurveGeo rot2(IVecI destDir)

      rotation on xy-plane towards destDir
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IParticleGeo`

    - #### rot2

          public IParticleOnCurveGeo rot2(IVecI center,
                                          IVecI destPt)

      rotation on xy-plane towards destPt
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in interface `IVecI`
      Overrides:
        `rot2` in class `IParticleGeo`

    - #### scale

          public IParticleOnCurveGeo scale(IDoubleI f)

      alias of mul
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IParticleGeo`

    - #### scale

          public IParticleOnCurveGeo scale(double f)

      alias of mul
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IParticleGeo`

    - #### scale

          public IParticleOnCurveGeo scale(IVecI center,
                                           IDoubleI f)

      Description copied from interface: `IVecI`
      scale from a center
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IParticleGeo`

    - #### scale

          public IParticleOnCurveGeo scale(IVecI center,
                                           double f)

      Description copied from interface: `IVecI`
      scale from a center
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IParticleGeo`

    - #### scale

          public IParticleOnCurveGeo scale(double centerX,
                                           double centerY,
                                           double centerZ,
                                           double f)

      Description copied from interface: `IVecI`
      scale from a center
      Specified by:
        `scale` in interface `IVecI`
      Overrides:
        `scale` in class `IParticleGeo`

    - #### scale1d

          public IParticleOnCurveGeo scale1d(IVecI axis,
                                             double f)

      scale only in 1 direction
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IParticleGeo`

    - #### scale1d

          public IParticleOnCurveGeo scale1d(IVecI axis,
                                             IDoubleI f)

      Description copied from interface: `IVecI`
      scale only in 1 direction
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IParticleGeo`

    - #### scale1d

          public IParticleOnCurveGeo scale1d(double axisX,
                                             double axisY,
                                             double axisZ,
                                             double f)

      Description copied from interface: `IVecI`
      scale only in 1 direction
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IParticleGeo`

    - #### scale1d

          public IParticleOnCurveGeo scale1d(IVecI center,
                                             IVecI axis,
                                             double f)

      Description copied from interface: `IVecI`
      scale only in 1 direction from a center
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IParticleGeo`

    - #### scale1d

          public IParticleOnCurveGeo scale1d(IVecI center,
                                             IVecI axis,
                                             IDoubleI f)

      Description copied from interface: `IVecI`
      scale only in 1 direction from a center
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IParticleGeo`

    - #### scale1d

          public IParticleOnCurveGeo scale1d(double centerX,
                                             double centerY,
                                             double centerZ,
                                             double axisX,
                                             double axisY,
                                             double axisZ,
                                             double f)

      Description copied from interface: `IVecI`
      scale only in 1 direction from a center
      Specified by:
        `scale1d` in interface `IVecI`
      Overrides:
        `scale1d` in class `IParticleGeo`

    - #### ref

          public IParticleOnCurveGeo ref(IVecI planeDir)

      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `ITransformable`
      Specified by:
        `ref` in interface `IVecI`
      Overrides:
        `ref` in class `IParticleGeo`

    - #### ref

          public IParticleOnCurveGeo ref(double planeX,
                                         double planeY,
                                         double planeZ)

      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `IVecI`
      Overrides:
        `ref` in class `IParticleGeo`

    - #### ref

          public IParticleOnCurveGeo ref(IVecI center,
                                         IVecI planeDir)

      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `ITransformable`
      Specified by:
        `ref` in interface `IVecI`
      Overrides:
        `ref` in class `IParticleGeo`

    - #### ref

          public IParticleOnCurveGeo ref(double centerX,
                                         double centerY,
                                         double centerZ,
                                         double planeX,
                                         double planeY,
                                         double planeZ)

      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `IVecI`
      Overrides:
        `ref` in class `IParticleGeo`

    - #### mirror

          public IParticleOnCurveGeo mirror(IVecI planeDir)

      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `mirror` in interface `ITransformable`
      Specified by:
        `mirror` in interface `IVecI`
      Overrides:
        `mirror` in class `IParticleGeo`

    - #### mirror

          public IParticleOnCurveGeo mirror(double planeX,
                                            double planeY,
                                            double planeZ)

      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `mirror` in interface `IVecI`
      Overrides:
        `mirror` in class `IParticleGeo`

    - #### mirror

          public IParticleOnCurveGeo mirror(IVecI center,
                                            IVecI planeDir)

      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `mirror` in interface `ITransformable`
      Specified by:
        `mirror` in interface `IVecI`
      Overrides:
        `mirror` in class `IParticleGeo`

    - #### mirror

          public IParticleOnCurveGeo mirror(double centerX,
                                            double centerY,
                                            double centerZ,
                                            double planeX,
                                            double planeY,
                                            double planeZ)

      reflect (mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `mirror` in interface `IVecI`
      Overrides:
        `mirror` in class `IParticleGeo`

    - #### shear

          public IParticleOnCurveGeo shear(double sxy,
                                           double syx,
                                           double syz,
                                           double szy,
                                           double szx,
                                           double sxz)

      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVecI`
      Overrides:
        `shear` in class `IParticleGeo`

    - #### shear

          public IParticleOnCurveGeo shear(IDoubleI sxy,
                                           IDoubleI syx,
                                           IDoubleI syz,
                                           IDoubleI szy,
                                           IDoubleI szx,
                                           IDoubleI sxz)

      Description copied from interface: `IVecI`
      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVecI`
      Overrides:
        `shear` in class `IParticleGeo`

    - #### shear

          public IParticleOnCurveGeo shear(IVecI center,
                                           double sxy,
                                           double syx,
                                           double syz,
                                           double szy,
                                           double szx,
                                           double sxz)

      Description copied from interface: `IVecI`
      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVecI`
      Overrides:
        `shear` in class `IParticleGeo`

    - #### shear

          public IParticleOnCurveGeo shear(IVecI center,
                                           IDoubleI sxy,
                                           IDoubleI syx,
                                           IDoubleI syz,
                                           IDoubleI szy,
                                           IDoubleI szx,
                                           IDoubleI sxz)

      Description copied from interface: `IVecI`
      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVecI`
      Overrides:
        `shear` in class `IParticleGeo`

    - #### shearXY

          public IParticleOnCurveGeo shearXY(double sxy,
                                             double syx)

      Description copied from interface: `IVecI`
      shear operation on XY
      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVecI`
      Overrides:
        `shearXY` in class `IParticleGeo`

    - #### shearXY

          public IParticleOnCurveGeo shearXY(IDoubleI sxy,
                                             IDoubleI syx)

      Description copied from interface: `IVecI`
      shear operation on XY
      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVecI`
      Overrides:
        `shearXY` in class `IParticleGeo`

    - #### shearXY

          public IParticleOnCurveGeo shearXY(IVecI center,
                                             double sxy,
                                             double syx)

      Description copied from interface: `IVecI`
      shear operation on XY
      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVecI`
      Overrides:
        `shearXY` in class `IParticleGeo`

    - #### shearXY

          public IParticleOnCurveGeo shearXY(IVecI center,
                                             IDoubleI sxy,
                                             IDoubleI syx)

      Description copied from interface: `IVecI`
      shear operation on XY
      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVecI`
      Overrides:
        `shearXY` in class `IParticleGeo`

    - #### shearYZ

          public IParticleOnCurveGeo shearYZ(double syz,
                                             double szy)

      Description copied from interface: `IVecI`
      shear operation on YZ
      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVecI`
      Overrides:
        `shearYZ` in class `IParticleGeo`

    - #### shearYZ

          public IParticleOnCurveGeo shearYZ(IDoubleI syz,
                                             IDoubleI szy)

      Description copied from interface: `IVecI`
      shear operation on YZ
      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVecI`
      Overrides:
        `shearYZ` in class `IParticleGeo`

    - #### shearYZ

          public IParticleOnCurveGeo shearYZ(IVecI center,
                                             double syz,
                                             double szy)

      Description copied from interface: `IVecI`
      shear operation on YZ
      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVecI`
      Overrides:
        `shearYZ` in class `IParticleGeo`

    - #### shearYZ

          public IParticleOnCurveGeo shearYZ(IVecI center,
                                             IDoubleI syz,
                                             IDoubleI szy)

      Description copied from interface: `IVecI`
      shear operation on YZ
      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVecI`
      Overrides:
        `shearYZ` in class `IParticleGeo`

    - #### shearZX

          public IParticleOnCurveGeo shearZX(double szx,
                                             double sxz)

      Description copied from interface: `IVecI`
      shear operation on ZX
      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVecI`
      Overrides:
        `shearZX` in class `IParticleGeo`

    - #### shearZX

          public IParticleOnCurveGeo shearZX(IDoubleI szx,
                                             IDoubleI sxz)

      Description copied from interface: `IVecI`
      shear operation on ZX
      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVecI`
      Overrides:
        `shearZX` in class `IParticleGeo`

    - #### shearZX

          public IParticleOnCurveGeo shearZX(IVecI center,
                                             double szx,
                                             double sxz)

      Description copied from interface: `IVecI`
      shear operation on ZX
      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVecI`
      Overrides:
        `shearZX` in class `IParticleGeo`

    - #### shearZX

          public IParticleOnCurveGeo shearZX(IVecI center,
                                             IDoubleI szx,
                                             IDoubleI sxz)

      Description copied from interface: `IVecI`
      shear operation on ZX
      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVecI`
      Overrides:
        `shearZX` in class `IParticleGeo`

    - #### translate

          public IParticleOnCurveGeo translate(double x,
                                               double y,
                                               double z)

      translate is alias of add()
      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in interface `IVecI`
      Overrides:
        `translate` in class `IParticleGeo`

    - #### translate

          public IParticleOnCurveGeo translate(IDoubleI x,
                                               IDoubleI y,
                                               IDoubleI z)

      Description copied from interface: `IVecI`
      alias of add()
      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in interface `IVecI`
      Overrides:
        `translate` in class `IParticleGeo`

    - #### translate

          public IParticleOnCurveGeo translate(IVecI v)

      Description copied from interface: `IVecI`
      alias of add()
      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in interface `IVecI`
      Overrides:
        `translate` in class `IParticleGeo`

    - #### transform

          public IParticleOnCurveGeo transform(IMatrix3I mat)

      Description copied from interface: `IVecI`
      transform with a transformation matrix
      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVecI`
      Overrides:
        `transform` in class `IParticleGeo`

    - #### transform

          public IParticleOnCurveGeo transform(IMatrix4I mat)

      Description copied from interface: `IVecI`
      transform with a transformation matrix
      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVecI`
      Overrides:
        `transform` in class `IParticleGeo`

    - #### transform

          public IParticleOnCurveGeo transform(IVecI xvec,
                                               IVecI yvec,
                                               IVecI zvec)

      Description copied from interface: `IVecI`
      transform with a transformation vectors
      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVecI`
      Overrides:
        `transform` in class `IParticleGeo`

    - #### transform

          public IParticleOnCurveGeo transform(IVecI xvec,
                                               IVecI yvec,
                                               IVecI zvec,
                                               IVecI translate)

      Description copied from interface: `IVecI`
      transform with a transformation vectors
      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVecI`
      Overrides:
        `transform` in class `IParticleGeo`

    - #### mv

          public IParticleOnCurveGeo mv(double x,
                                        double y,
                                        double z)

      mv() is alias of add()
      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in interface `IVecI`
      Overrides:
        `mv` in class `IParticleGeo`

    - #### mv

          public IParticleOnCurveGeo mv(IDoubleI x,
                                        IDoubleI y,
                                        IDoubleI z)

      Description copied from interface: `IVecI`
      mv() is alias of add()
      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in interface `IVecI`
      Overrides:
        `mv` in class `IParticleGeo`

    - #### mv

          public IParticleOnCurveGeo mv(IVecI v)

      Description copied from interface: `IVecI`
      mv() is alias of add()
      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in interface `IVecI`
      Overrides:
        `mv` in class `IParticleGeo`

    - #### cp

          public IParticleOnCurveGeo cp()

      cp() is alias of dup()
      Specified by:
        `cp` in interface `IArithmeticVal<IVecI,IDoubleI>`
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVecI`
      Overrides:
        `cp` in class `IParticleGeo`

    - #### cp

          public IParticleOnCurveGeo cp(double x,
                                        double y,
                                        double z)

      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVecI`
      Overrides:
        `cp` in class `IParticleGeo`

    - #### cp

          public IParticleOnCurveGeo cp(IDoubleI x,
                                        IDoubleI y,
                                        IDoubleI z)

      Description copied from interface: `IVecI`
      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVecI`
      Overrides:
        `cp` in class `IParticleGeo`

    - #### cp

          public IParticleOnCurveGeo cp(IVecI v)

      Description copied from interface: `IVecI`
      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVecI`
      Overrides:
        `cp` in class `IParticleGeo`